import es, cfglib, cmdlib, gamethread, langlib, os, playerlib, popuplib, random, usermsg, vecmath

info = es.AddonInfo()
info.name = 'LooneyHostage'
info.basename = info.name.lower()
info.version = '1.0'
info.url = 'http://addons.eventscripts.com/addons/view/LooneyHostage'
info.author = 'Satoon101'
es.ServerVar('%s_version'%info.basename, info.version, '%s Version'%info.name).makepublic()

addonpath = es.getAddonPath(info.basename)

config_text = lambda text: '%s\n// ** %s **\n// %s'%('*'*(len(text) + 6), text, '*'*(len(text) + 6))

config = cfglib.AddonCFG(addonpath + '/lh_config.cfg')
config.text(config_text('LooneyHostage Command Options'))
lh_add_command = config.cvar('lh_add_command', '!add_hostage', "Say/Client Command to add a hostage location at player's current location\n// Can only be used by Admins")
lh_remove_command = config.cvar('lh_remove_command', '!remove_hostage', 'Say/Client Command to remove a hostage location from current map\n// Can only be used by Admins\n// Will display a list of all locations available to be removed\n// You can also just manually edit your hostage_locations.ini file')
lh_location_command = config.cvar('lh_location_command', '!location', 'Say/Client Command to get current location\n// Can only be used by Admins\n// Use this command to find your location to know which hostage location you wish to remove')
config.text('\n\n')
config.text(config_text('LooneyHostage Rescue System Options'))
lh_rescue_points = config.cvar('lh_rescue_points', 0, 'Number of points to add to the score of a player that rescues a hostage.\n// No points will be added for inactive hostages')
lh_rescue_cash = config.cvar('lh_rescue_cash', 1000, 'Amount of cash to give a player that rescues a hostage.\n// No cash will be given for inactive hostages')

config_comments = {
    'active':[
        'Active Hostages will follow players to the rescue zone',
        'Active Hostages act as normal and allow you to score points and get cash',
        '',
        'If you set the number of Active Hostages to higher than what are already spawned on the map,',
        'Bots will not try to activate the ones that are spawned by this script',
             ],
    'inactive':[
        'Inactive Hostages will refuse to follow players to the rescue zone',
        'Inactive Hostages will be deactivated on use',
        '',
        'Once all living Active Hostages have been rescued,',
        'All Inactive Hostages will be auto-rescued (and no cash/points will be given for rescuing them)',
        '',
        'All Inactive Hostages are spawned by this script',
        'Due to this, no Bot should ever try to activate them',
               ],
                  }

ini = cfglib.AddonINI(addonpath + '/strings.ini')
ini.addValueToGroup('Show Active', 'en', 'Active: $rescued/$active')
ini.addValueToGroup('Show Inactive', 'en', 'Inactive: $inactive')
ini.addValueToGroup('Follows', 'en', '#green$hostage_name#default is now following you')
ini.addValueToGroup('Stops Following', 'en', '#green$hostage_name#default has stopped following you')
ini.addValueToGroup('Killed', 'en', '#green$hostage_name#default has been slain by#lightgreen $player_name')
ini.addValueToGroup('Respawned', 'en', '#green$hostage_name#default has been reincarnated')
ini.addValueToGroup('Rescued', 'en', '#lightgreen$player_name#default has rescued#green $hostage_name')
ini.addValueToGroup('Not Active', 'en', '#green$hostage_name#default is not active.  Find someone else to save')
ini.addValueToGroup('Remove', 'en', 'Choose a location to Remove:')
ini.addValueToGroup('Sure', 'en', 'Remove location?:')
ini.addValueToGroup('Yes', 'en', 'Yes')
ini.addValueToGroup('No', 'en', 'No')
ini.addValueToGroup('Location', 'en', '#defaultYour current location is#green $location')
for group in ini:
    ini.setGroupComments(group, [])
ini.write()
lh_lang = langlib.Strings(ini)

lh_hostage_locations = cfglib.AddonINI(addonpath + '/hostage_locations.ini')
hostage_location_comments = [
    'The default locations for each hostage map are auto-added to this file the first time you load the map with this script running',
    'There are 2 ways to add/remove locations from this file',
    '',
    'First, you can just edit it to your liking with whichever text editor you prefer (and are currently using to view this file)',
    '',
    'Second, when in-game, Admins can use the add command to add their current location,',
    'or the remove command to remove a location via menu',
    'To get their current location, in order to know which location to remove,',
    'Admins can also use the location command to be sent their current location',
    'All three of these commands are configurable in you lh_config.cfg',
    '\n',
    'The syntax for this file as far as locations is:'
    '',
    '[<mapname>]',
    '<location> = <angle>',
    '',
    'The <angle> is which direction the hostage should be facing',
    'So when using the add command, make sure you are facing the direction you with the hostage to be facing',
                            ]
lh_hostage_locations.setInitialComments(hostage_location_comments)
lh_hostage_locations.write()

lh_hostage_names = cfglib.AddonINI(addonpath + '/hostage_names.ini')
if not len(lh_hostage_names):
    lh_hostage_names.addValueToGroup('Bob', 'model', 'models/characters/hostage_01.mdl')
    lh_hostage_names.addValueToGroup('Bob', 'sound', 'hostage')
    lh_hostage_names.addValueToGroup('Sam', 'model', 'models/characters/hostage_02.mdl')
    lh_hostage_names.addValueToGroup('Sam', 'sound', 'hostage')
    lh_hostage_names.addValueToGroup('Alan', 'model', 'models/characters/hostage_03.mdl')
    lh_hostage_names.addValueToGroup('Alan', 'sound', 'hostage')
    lh_hostage_names.addValueToGroup('Roger', 'model', 'models/characters/hostage_04.mdl')
    lh_hostage_names.addValueToGroup('Roger', 'sound', 'hostage')
hostage_name_comments = [
    'Please keep the following syntax when adding/removing/changing Hostage Names and their data:',
    '',
    '[<Name>]',
    "model = '<path to model>'",
    "sound = '<path to sounds>'",
    '\n',
    '<path to model> needs to be the model location starting with models/ and ending in .mdl that your model is located at',
    '\n',
    '<path to sounds> needs to be a folder (from your sound/ directory) that holds 3 other folders',
    'The three other folders are hpain, hunuse, and huse',
    'The default sounds are located in your sound/hostage/ directory, so look there for reference',
    "Note that since sound/hostage/ is the default directory, the default value for this script is 'hostage'",
    'You can include as many sounds in each of the 3 directories as you want',
    'The script will choose one at random each time the even occurs for one of the sounds',
    '\n',
    'If you are using custom models, you should also add any of the other files that need to be downloaded to each client',
    'Make sure that the path you use for those files are from your cstrike/ folder, but do not include cstrike/ as part of the path',
    'The syntax for adding (for instance) "cstrike/models/characters/hostage_03.phy" and "cstrike/materials/models/hostages/mouth.vmt" would be:',
    '',
    '[<Name>]',
    "model = '<path to model>'",
    "sound = '<path to sounds>'",
    "1 = 'models/characters/hostage_03.phy'",
    "2 = 'materials/models/hostages/mouth.vmt'",
                        ]
lh_hostage_names.setInitialComments(hostage_name_comments)
for group in lh_hostage_names:
    lh_hostage_names.setGroupComments(group, [])
lh_hostage_names.write()

sound_dir = os.path.join(str(es.ServerVar('eventscripts_gamedir')), 'sound')
currentmap = es.ServerVar('eventscripts_currentmap')

PlayerList = {}

class Player:
    def __init__(self, userid):
        self.userid = userid
        player = playerlib.getPlayer(self.userid)
        self.lang = player.lang
        self.isbot = player.isbot
    
    def sendRemovePopup(self):
        mapname = str(currentmap)
        self.removepopup = popuplib.easymenu('Remove %s'%self.userid, 'choice', self.verifyRemove)
        self.removepopup.settitle(lh_lang('Remove', lang=self.lang))
        for location in lh_hostage_locations[mapname]:
            self.removepopup.addoption((mapname, location), location)
        self.removepopup.send(self.userid)
    
    def verifyRemove(self, userid, (mapname, location), popupid):
        self.verifypopup = popuplib.easymenu('Verify %s'%self.userid, 'choice', self.locationRemove)
        self.verifypopup.settitle(lh_lang('Sure', lang=self.lang))
        self.verifypopup.addoption((mapname, location), lh_lang('Yes', lang=self.lang))
        self.verifypopup.addoption((False, False), lh_lang('No', lang=self.lang))
        self.verifypopup.send(self.userid)
    
    def locationRemove(self, userid, (mapname, location), popupid):
        if mapname:
            hostages.deleteLocation(mapname, location)
        self.removepopup.delete()
        self.verifypopup.delete()
    
    def sendPlayerChatMessage(self, message, tokens={}):
        es.tell(self.userid, '#multi', lh_lang(message, tokens, self.lang))
    
    def showHudHint(self, rescued, active, inactive):
        message = lh_lang('Show Active', {'rescued':rescued, 'active':active}, self.lang)
        message += '\n ' + lh_lang('Show Inactive', {'inactive':inactive}, self.lang) if inactive else ''
        usermsg.hudhint(self.userid, message)

class MainHostageManagement:
    class HostageGroupHandler:
        class HostageIndexHandler:
            def __init__(self, index, location, hostage_name):
                self.index = index
                self.location = location
                self.name = hostage_name.name
                self.model = hostage_name.model
                self.sounds = hostage_name.sounds
                self.first = 1
                es.setindexprop(self.index, 'CBaseEntity.m_nModelIndex', es.precachemodel(self.model))
                es.setindexprop(self.index, 'CBaseEntity.m_clrRender', -1)
            
            def playSound(self, event):
                if len(self.sounds[event]):
                    es.emitsound('entity', self.index, random.choice(self.sounds[event]), 1.0, 1.0)
        
        def __init__(self, name):
            self.active = int(name == 'active')
            self.indexes = {}
            self.locations = set()
            self.total = 0
            self.rescued = 0
            config.text('\n\n')
            config.text(config_text('LooneyHostage %s Hostage Options'%name.capitalize()))
            for comment in config_comments[name]:
                config.text(comment)
            self.minimum = config.cvar('lh_%s_hostage_minimum'%name, 1, 'Set this to the minimum amount of %s hostages to use'%name)
            self.maximum = config.cvar('lh_%s_hostage_maximum'%name, 4, 'Set this to the maximum amount of %s hostages to use\n// Set this to the same as lh_%s_hostage_minimum to always use the same amount'%(name,name))
            self.health = config.cvar('lh_%s_hostage_health'%name, 100, 'Amount of health for %s hostages'%name)
            self.godmode = config.cvar('lh_%s_hostage_godmode'%name, 0, 'Enable/Disable %s from being able to get hurt'%name)
            self.respawn = config.cvar('lh_%s_hostage_respawn'%name, 0, '0 = Do not respawn %s hostages when they are killed\n// 1 = Respawn killed %s hostages in their original position\n// 2 = Choose a new random location to respawn killed %s hostages'%(name, name, name))
            self.use_sounds = config.cvar('lh_%s_hostage_sounds'%name, 0, 'Enable/Disable using sounds set in hostage_names for events for %s hostages'%name)
            self.cash = config.cvar('lh_%s_hostage_activate_cash'%name, 150, 'Amount of cash to give the player who first activates each %s hostage'%name)
        
        def reset(self):
            self.indexes.clear()
            self.locations.clear()
            self.rescued = 0
            self.total = 0
    
    class HostageNameHandler:
        def __init__(self, name):
            self.name = name
            self.downloadables = set()
            values = lh_hostage_names[self.name]
            self.model = values['model']
            self.sounds = {'hpain':[], 'hunuse':[], 'huse':[]}
            self.sound_folder = values['sound']
            os_sound_folder = os.path.join(sound_dir, self.sound_folder)
            for sound_type in self.sounds:
                current_folder = os.path.join(os_sound_folder, sound_type)
                if os.path.isdir(current_folder):
                    for sound_file in os.listdir(current_folder):
                        sound_path = os.path.join(self.sound_folder, sound_type, sound_file)
                        self.sounds[sound_type].append(sound_path)
                        self.downloadables.add(os.path.join('sound', sound_path))
            for value in values:
                if value != 'sound':
                    self.downloadables.add(values[value])
        
        def doDownloads(self):
            for download_file in self.downloadables:
                es.stringtable('downloadables', download_file)
    
    class RescueLocationHandler:
        def __init__(self, index):
            self.index = index
            self.mins = map(float, es.getindexprop(index, 'CBaseEntity.m_Collision.m_vecMins').split(','))
            self.maxs = map(float, es.getindexprop(index, 'CBaseEntity.m_Collision.m_vecMaxs').split(','))
            self.center = map(lambda x, y: (x + y) / 2, self.mins, self.maxs)
            self.location = ' '.join(map(str, self.center))
        
        def isHostageBetweenRect(self, location):
            return vecmath.isbetweenRect(location, self.mins, self.maxs)
        
        def getHostageDistance(self, location):
            return sum(map(lambda x, y: (x - y) ** 2, location, self.center)) ** 0.5
        
        def getClosestPlayer(self):
            closest_player = sorted(playerlib.getPlayerList('#ct,#alive'), key=lambda player: self.getHostageDistance(player.location.split(',')))[0]
    
    def __init__(self):
        self.active_hostages = self.HostageGroupHandler('active')
        self.inactive_hostages = self.HostageGroupHandler('inactive')
        self.using_names = set()
        self.existing_hostages = set()
        self.map_locations = {}
        self.rescue_locations = {}
        self.hostage_names = {}
        for hostage_name in lh_hostage_names:
            self.hostage_names[hostage_name] = self.HostageNameHandler(hostage_name)
        self.round_active = False
    
    def doLoad(self, mapname):
        self.add_command = str(lh_add_command)
        self.remove_command = str(lh_remove_command)
        self.location_command = str(lh_location_command)
        for command, callback, description in ((self.add_command, self.addLocation, 'Add location'), (self.remove_command, self.removeLocation, 'Remove a location'), (self.location_command, self.sendLocation, 'Send player current location')):
            if command:
                cmdlib.registerSayCommand(command, callback, description, 'looneyhostage_addremove_hostage', 'ADMIN')
                cmdlib.registerClientCommand(command, callback, description, 'looneyhostage_addremove_hostage', 'ADMIN')
        gamethread.queue(self.checkMap, mapname)
    
    def unLoad(self):
        for command in (self.add_command, self.remove_command, self.location_command):
            if command:
                cmdlib.unregisterSayCommand(command)
                cmdlib.unregisterClientCommand(command)
        self.stopHudHint()
    
    def mapStart(self, mapname):
        self.rescue_locations.clear()
        gamethread.queue(self.checkMap, mapname)
    
    def checkMap(self, mapname):
        es.loadevents('declare', 'addons/eventscripts/looneyhostage/looneyhostage_events.res')
        if not len(mapname): return
        if mapname in lh_hostage_locations: return
        if not len(es.createentitylist('func_hostage_rescue')): return
        hostage_entities = es.createentitylist('hostage_entity')
        if not len(hostage_entities): return
        lh_hostage_locations.addGroup(mapname)
        for index in hostage_entities:
            self.addNewLocation(index)
        self.hostageDownloads()
    
    def hostageDownloads(self):
        for hostage_name in self.hostage_names:
            self.hostage_names[hostage_name].doDownloads()
    
    def addLocation(self, userid, args):
        if not str(currentmap) in lh_hostage_locations: return
        self.addNewLocation(playerlib.getPlayer(userid).index)
    
    def addNewLocation(self, index):
        lh_hostage_locations.addValueToGroup(str(currentmap), es.entitygetvalue(index, 'origin'), es.entitygetvalue(index, 'angles'))
        self.writeLocations()
    
    def deleteLocation(self, mapname, location):
        if not mapname in lh_hostage_locations: return
        if location in lh_hostage_locations[mapname]:
            lh_hostage_locations.delValueFromGroup(mapname, location)
            self.writeLocations()
    
    def roundStart(self):
        if not str(currentmap) in lh_hostage_locations: return
        self.getRescueLocations()
        self.active_hostages.reset()
        self.inactive_hostages.reset()
        self.using_names.clear()
        self.map_locations.clear()
        for index in es.createentitylist('hostage_entity'):
            self.existing_hostages.add(index)
        self.spawnAllHostages()
    
    def getRescueLocations(self):
        if len(self.rescue_locations): return
        rescue_zones = es.createentitylist('func_hostage_rescue')
        for index in rescue_zones:
            self.rescue_locations[index] = self.RescueLocationHandler(index)
    
    def spawnAllHostages(self):
        self.map_locations = dict(lh_hostage_locations[str(currentmap)])
        all_locations = set(self.map_locations)
        for group in (self.active_hostages, self.inactive_hostages):
            amount = random.randint(int(group.minimum), int(group.maximum))
            group.locations = set(random.sample(all_locations, min(amount, len(all_locations))))
            group.total = len(group.locations)
            all_locations = all_locations.difference(group.locations)
            for location in group.locations:
                self.spawnHostage(group, location)
        userid = es.getuserid()
        if userid:
            for index in self.existing_hostages:
                es.entitysetvalue(index, 'targetname', 'looneyhostage_entity')
            es.fire(userid, 'looneyhostage_entity', 'kill')
        else:
            es.server.queuecmd('es_xremove %s'%index)
        self.existing_hostages.clear()
    
    def spawnHostage(self, group, location, old_index=0, old_name=None):
        if group.active and len(self.existing_hostages):
            index = self.existing_hostages.pop()
        else:
            index = es.createentity('hostage_entity')
            es.spawnentity(index)
        es.entitysetvalue(index, 'origin', location)
        es.entitysetvalue(index, 'angles', lh_hostage_locations[str(currentmap)][location])
        hostage = group.indexes[index] = group.HostageIndexHandler(index, location, self.findName(old_name))
        group.locations.add(location)
        x, y, z = location.split(' ')
        self.fireHostageEvent('lh_hostage_spawned', {'hostage':index, 'x':x, 'y':y, 'z':z, 'hostage_name':hostage.name, 'hostage_model':hostage.model, 'active':group.active, 'old_index':old_index})
    
    def findName(self, old_name):
        if not old_name is None: return self.hostage_names[old_name]
        if len(self.hostage_names) > len(self.using_names):
            hostage_name = random.choice(list(set(self.hostage_names).difference(self.using_names)))
            self.using_names.add(hostage_name)
        else:
            hostage_name = random.choice(list(self.hostage_names))
        return self.hostage_names[hostage_name]
    
    def hostageEvents(self, event, hostage, userid=None):
        group = self.findGroup(hostage)
        if group is None: return
        site = first = damage = None
        if event == 'lh_hostage_rescued':
            site = self.getHostageRescueZone(map(float, es.entitygetvalue(hostage, 'origin').split(' ')))
        if event == 'lh_hostage_follows':
            first = group.indexes[hostage].first
        if event == 'lh_hostage_hurt':
            current_health = int(es.getindexprop(hostage, 'CHostage.m_iHealth'))
            damage = group.indexes[hostage].health - current_health
            group.indexes[hostage].health = current_health
        self.fireHostageEvent(event, {'userid':userid, 'hostage':hostage, 'site':site, 'damage':damage, 'hostage_name':group.indexes[hostage].name, 'hostage_model':group.indexes[hostage].model, 'active':group.active, 'first':first})
    
    def hostageSpawned(self, hostage, old_index):
        group = self.findGroup(hostage)
        if group is None: return
        es.setindexprop(hostage, 'CHostage.m_iHealth', group.health)
        group.indexes[hostage].health = int(group.health)
        if group.godmode:
            es.setindexprop(hostage, 'CHostage.m_lifeState', 0)
        if old_index:
            for userid in playerlib.getUseridList('#human,#ct'):
                getUser(userid).sendPlayerChatMessage('Respawned', {'hostage_name':group.indexes[hostage].name})
    
    def hostageFollows(self, hostage, userid):
        self.hostageCheckSound('huse', hostage)
        group = self.findGroup(hostage)
        if group is None: return
        if group.indexes[hostage].first:
            group.indexes[hostage].first = 0
            playerlib.getPlayer(userid).cash += group.cash - 150
        getUser(userid).sendPlayerChatMessage('Follows' if group.active else 'Not Active', {'hostage_name':group.indexes[hostage].name})
        if not group.active:
            es.setindexprop(hostage, 'CHostage.m_leader', 0)
    
    def hostageStopsFollowing(self, hostage, userid):
        self.hostageCheckSound('hunuse', hostage)
        group = self.findGroup(hostage)
        if not group is None and group.active:
            getUser(userid).sendPlayerChatMessage('Stops Following', {'hostage_name':group.indexes[hostage].name})
    
    def hostageKilled(self, hostage, userid):
        group = self.findGroup(hostage)
        if group is None: return
        old_name = group.indexes[hostage].name
        if int(userid):
            username = es.getplayername(userid)
            for userid in playerlib.getUseridList('!un,!spec,#human'):
                getUser(userid).sendPlayerChatMessage('Killed', {'hostage_name':old_name, 'player_name':username})
        if not len(es.createentitylist('hostage_entity')): return
        location = group.indexes[hostage].location
        group.locations.remove(location)
        del group.indexes[hostage]
        if group.respawn:
            if group.respawn == 2:
                all_locations = set(self.map_locations)
                choice_locations = all_locations.difference(self.active_hostages.locations).difference(self.inactive_hostages.locations)
                if len(choice_locations):
                    location = random.choice(list(choice_locations))
            self.spawnHostage(group, location, hostage, old_name)
        elif group.active and not len(self.active_hostages.indexes) and len(playerlib.getPlayerList('#ct,#alive')):
            location, handle = self.getNearPlayerRescue()
            self.rescueAllHostages(location, handle)
        else:
            group.total -= 1
            self.refreshHudHint()
    
    def hostageRescued(self, hostage, userid, site):
        group = self.findGroup(hostage)
        if group is None: return
        player = playerlib.getPlayer(userid)
        player.cash += (lh_rescue_cash if group.active else 0) - 1000
        if group.active and lh_rescue_points:
            es.server.queuecmd('score add %s %s'%(userid, lh_rescue_points))
        if group.active:
            group.rescued += 1
            for userid in playerlib.getUseridList('#human,#ct'):
                getUser(userid).sendPlayerChatMessage('Rescued', {'player_name':player.name, 'hostage_name':group.indexes[hostage].name})
        del group.indexes[hostage]
        if group.active and not len(self.active_hostages.indexes):
            self.rescueAllHostages(self.rescue_locations[site].location, player.handle)
        elif group.active:
            self.refreshHudHint()
    
    def rescueAllHostages(self, location, handle):
        not_rescued = filter(lambda index: not es.getindexprop(index, 'CHostage.m_isRescued'), es.createentitylist('hostage_entity'))
        alive_not_rescued = filter(lambda index: es.getindexprop(index, 'CHostage.m_iHealth'), not_rescued)
        for index in alive_not_rescued:
            es.setindexprop(index, 'CBaseEntity.m_CollisionGroup', '2')
            es.entitysetvalue(index, 'origin', location)
            es.setindexprop(index, 'CHostage.m_leader', handle)
    
    def getNearPlayerRescue(self):
        distances = {}
        for rescue_zone in self.rescue_locations:
            distances[rescue_zone] = self.rescue_locations[rescue_zone].getClosestPlayer()
    
    def getHostageRescueZone(self, location):
        for index in self.rescue_locations:
            if self.rescue_locations[index].isHostageBetweenRect(location): return index
        return sorted(self.rescue_locations, key=lambda rescue_zone: self.rescue_locations[rescue_zone].getHostageDistance(location))[0]
    
    def hostageCheckSound(self, event, hostage):
        group = self.findGroup(hostage)
        if not group is None:
            self.hostagePlaySound(event, hostage, group)
    
    def findGroup(self, hostage):
        for group in (self.active_hostages, self.inactive_hostages):
            if hostage in group.indexes: return group
        return None
    
    def startHudHint(self):
        self.round_active = True
        self.showHudHint()
    
    def refreshHudHint(self):
        gamethread.cancelDelayed('lh_showHudHint')
        self.showHudHint()
    
    def showHudHint(self):
        if not self.round_active: return
        for userid in playerlib.getUseridList('#human,#ct'):
            getUser(userid).showHudHint(self.active_hostages.rescued, self.active_hostages.total, self.inactive_hostages.total)
        gamethread.delayedname(3, 'lh_showHudHint', self.showHudHint)
    
    def stopHudHint(self):
        self.round_active = False
        gamethread.cancelDelayed('lh_showHudHint')
    
    @staticmethod
    def hostagePlaySound(event, hostage, group):
        if group.use_sounds:
            group.indexes[hostage].playSound(event)
    
    @staticmethod
    def removeLocation(userid, args):
        getUser(userid).sendRemovePopup()
    
    @staticmethod
    def sendLocation(userid, args):
        getUser(userid).sendPlayerChatMessage('Location', {'location':' '.join(map(str, es.getplayerlocation(userid)))})
    
    @staticmethod
    def writeLocations():
        for mapname in lh_hostage_locations:
            lh_hostage_locations.setGroupComments(mapname, [])
        lh_hostage_locations.write()
    
    @staticmethod
    def fireHostageEvent(event, variables):
        es.event('initialize', event)
        for variable in variables:
            if variables[variable] is None: continue
            value = str(variables[variable])
            value_type = 'setfloat' if len(value.split('.')) == 2 and value.replace('.', '').isdigit() else 'setint' if value.isdigit() else 'setstring'
            es.event(value_type, event, variable, value)
        es.event('fire', event)

hostages = MainHostageManagement()

config.write()

def getUser(userid):
    userid = str(userid)
    if not userid in PlayerList:
        PlayerList[userid] = Player(userid)
    return PlayerList[userid]

def load():
    config.execute()
    gamethread.delayed(.1, hostages.doLoad, str(currentmap))

def unload():
    hostages.unLoad()

def es_map_start(ev):
    PlayerList.clear()
    hostages.mapStart(ev['mapname'])

def player_disconnect(ev):
    userid = ev['userid']
    if userid in PlayerList:
        del PlayerList[userid]

def round_start(ev):
    hostages.roundStart()

def round_freeze_end(ev):
    hostages.startHudHint()

def round_end(ev):
    hostages.stopHudHint()

def hostage_follows(ev):
    hostages.hostageEvents('lh_hostage_follows', int(ev['hostage']), ev['userid'])

def hostage_stops_following(ev):
    hostages.hostageEvents('lh_hostage_stops_following', int(ev['hostage']), ev['userid'])

def hostage_hurt(ev):
    hostages.hostageEvents('lh_hostage_hurt', int(ev['hostage']), ev['userid'])

def hostage_killed(ev):
    hostages.hostageEvents('lh_hostage_killed', int(ev['hostage']), ev['userid'])

def hostage_rescued(ev):
    hostages.hostageEvents('lh_hostage_rescued', int(ev['hostage']), ev['userid'])

def hostage_call_for_help(ev):
    hostages.hostageEvents('lh_hostage_call_for_help', int(ev['hostage']))

def lh_hostage_spawned(ev):
    hostages.hostageSpawned(int(ev['hostage']), int(ev['old_index']))

def lh_hostage_follows(ev):
    hostages.hostageFollows(int(ev['hostage']), ev['userid'])

def lh_hostage_rescued(ev):
    hostages.hostageRescued(int(ev['hostage']), ev['userid'], int(ev['site']))

def lh_hostage_killed(ev):
    hostages.hostageKilled(int(ev['hostage']), ev['userid'])

def lh_hostage_stops_following(ev):
    hostages.hostageStopsFollowing(int(ev['hostage']), ev['userid'])

def lh_hostage_hurt(ev):
    hostages.hostageCheckSound('hpain', int(ev['hostage']))